#!/usr/bin/python
# -*- coding: iso-8859-15 -*-
"""
$Id$

This file is part of the anontwi project, http://anontwi.sourceforge.net.

Copyright (c) 2012/2015 psy <root@lordepsylon.net> - <epsylon@riseup.net>

anontwi is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation version 3 of the License.

anontwi is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
details.

You should have received a copy of the GNU General Public License along
with anontwi; if not, write to the Free Software Foundation, Inc., 51
Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
"""
from Crypto import Random
from Crypto.Cipher import AES
from Crypto.Cipher import Blowfish
from base64 import b64encode, b64decode

class Cipher(object):
    """
    Cipher class
    """
    def __init__(self, key="", text=""):
        """
        Init 
        """
        self.block_size = 16
        self.padding = '{'
        self.key = self.set_key(key)
        self.text = self.set_text(text)
        self.mode_aes = AES.MODE_CBC
        self.mode_blow = Blowfish.MODE_CBC
        self.aes_encryptor = ""
        self.blow_encryptor = ""
        self.aes_decryptor = ""
        self.blow_decryptor = ""
        self.ciphertext = ""
        self.ciphertext2 = ""
        self.plaintext = ""
        self.plaintext2 = ""
  
    def set_key(self, key):
        """
        Set key
        """
        self.key = key
        return self.key	

    def set_text(self, text):
        """
        Set text
        """
        self.text = text 
        return self.text

    def encrypt(self):
        """
        Encrypt text (AES+Blowfish+B64)
        """
        pad = lambda text: self.text + (self.block_size - len(self.text) % self.block_size) * self.padding
        
	# Advanced Encryption Standard cipher
        self.aes_encryptor = AES.new(self.key) #, self.mode_aes)
        self.ciphertext = self.aes_encryptor.encrypt(pad(self.text))
        # Blowfish symmetric cipher
        self.blow_encryptor = Blowfish.new(self.key)
        self.ciphertext2 = self.blow_encryptor.encrypt(self.ciphertext)
        return b64encode(self.ciphertext2)

    def decrypt(self):
        """
        Decrypt text
        """
        self.blow_decryptor = Blowfish.new(self.key)
        self.text = b64decode(self.text)
        self.plaintext2 = self.blow_decryptor.decrypt(self.text).rstrip(self.padding)
        # Advanced Encryption Standard cipher
        self.aes_decryptor = AES.new(self.key) #, self.mode_aes)
        self.plaintext = self.aes_decryptor.decrypt(self.plaintext2).rstrip(self.padding)
        return self.plaintext

#if __name__ == "__main__":
#    key = '0123456789abcdef'
#    text = sys.argv[1]
#    print "texto",text
#    e = Cipher(key,text)
#    ciphertext=e.encrypt()
#    print "ciphertext",ciphertext
#    d = Cipher(key,ciphertext)
#    plaintext=d.decrypt()
#    print "plaintext",plaintext   

