#!/usr/bin/python
# -*- coding: iso-8859-15 -*-
"""
$Id$

This file is part of the anontwi project, http://twitwi.sourceforge.net.

Copyright (c) 2012/2015 psy <root@lordepsylon.net> - <epsylon@riseup.net>

anontwi is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation version 3 of the License.

anontwi is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
details.

You should have received a copy of the GNU General Public License along
with anontwi; if not, write to the Free Software Foundation, Inc., 51
Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
"""
import optparse

class AnonTwiOptions(optparse.OptionParser):
    def __init__(self, *args):
        optparse.OptionParser.__init__(self, 
                           description='FIGHT CENSORSHIP!! being more safe on Twitter...',
                           prog='anontwi.py',
			   version='\nAnonTwi v0.1 - 2012 - (GPLv3.0) -> by psy\n',
                           usage= '\n\n Check README for: info, examples and forms to contact\n\n ./anontwi [-m <text> | -r <ID> | -d @user | -f @nick | --df @nick] [OPTIONS] <token key> <token secret>')

        #self.add_option("-v", "--verbose", action="store_true", dest="verbose", help="active verbose mode output results")

        group4 = optparse.OptionGroup(self, "API")
        group4.add_option("--tokens", action="store_true", dest="tokens", help="show your OAuth 'key' and 'secret' tokens (REQUIRED!) ")
        self.add_option_group(group4)

        group3 = optparse.OptionGroup(self, "Controller")
        group3.add_option("-m", action="store", dest="tweet", help="send a spoofed TWEET (ex: -m 'text')")
        group3.add_option("-r", action="store", dest="retweet", help="reTWEET and existing message (ex: -r 'ID')")
        group3.add_option("-d", action="store", dest="dm", help="send a spoofed DM (ex: -m 'text' -d '@user')")
        #group3.add_option("-i", action="store", dest="image", help="send an IMAGE, using spoofed headers and fake metadata")
        group3.add_option("-f", action="store", dest="friend", help="create friendship with a user (ex: -f '@user')")
        group3.add_option("--df", action="store", dest="dfriend", help="destroy friendship with a user (ex: --df '@user')")
        #group3.add_option("--mf", action="store", dest="massfriend", help="create massive friendships (ex: --fm 'list.txt')")
        #group3.add_option("--md", action="store", dest="massdfriend", help="destroy massive friendships (ex: --fm 'list.txt')")
        #group3.add_option("--gtk", action="store_true", dest="gtk", help="start GTK+ Window Interface (visual mode)")
        self.add_option_group(group3)

        group1 = optparse.OptionGroup(self, "Miscellania")
        group1.add_option("--proxy", action="store", dest="proxy", help="use proxy server (tor: --proxy 'http://localhost:8118')")
        group1.add_option("--ts", action="store", dest="search", help="search a number of results (ex: --ts '#15m 10')")
        #group1.add_option("--tt", action="store_true", dest="topics", help="check Trending Topics order by country (ex: '--tt 'spain')")
        group1.add_option("--tu", action="store", dest="timeline", help="show a number of tweets of a user (ex: --tu '@nick 5')")
        group1.add_option("--tf", action="store", dest="timelinef", help="show tweets of user's friends (ex: --tf '@nick 5')")
        #group1.add_option("--gps", action="store", dest="location", help="send a fake geolocation place (ex: --gps 'belice')")
        group1.add_option("--me", action="store", dest="mentions", help="returns the most recent mentions about you (ex: --me '5')")
        group1.add_option("--waves", action="store_true", dest="wave", help="split long message into waves (ex: -m 'text' --waves)")
        self.add_option_group(group1)

        group2 = optparse.OptionGroup(self, "Encryption (Tweet and DM)")
        group2.add_option("--enc", action="store_true", dest="encaes", help="encrypt using AES + Blowfish (PIN key size: 16, 24, 32)")
        group2.add_option("--dec", action="store", dest="decaes", help="decrypt messages from raw input or tweet's url")
        group2.add_option("--pin", action="store", dest="key", help="PIN key to cypher/decypher messages (share this secret!)")
        self.add_option_group(group2)

    def get_options(self, user_args=None):
        (options, args) = self.parse_args(user_args)
        options.args = args
        if (not options.tokens and not options.tweet and not options.dm and not options.search and not options.friend and not options.dfriend and not options.retweet and not options.timeline and not options.timelinef and not options.mentions and not options.decaes):
            print '='*75
            print  self.version
            print '='*75, "\n"
            print "           .   :   .            "
            print "       '.   .  :  .   .'        "
            print "    ._   '._.-'''-._.'   _.     #15M "
            print "      '-..'         '..-'       "
            print "   --._ /.==.     .==.\ _.--    #HackSol"
            print "       ;/_o__\   /_o__\;        "
            print "  -----|`     ) (     `|-----   #spanishrevolution"
            print "      _: \_) (\_/) (_/ ;_       "
            print "   --'  \  '._.=._.'  /  '--    #worldrevolution"
            print "     _.-''.  '._.'  .''-._      "
            print "    '    .''-.(_).-''.    '     "
            print "        '   '  :  '   '.        "
            print "           '   :   '            Share about R/evolution, not about you!"
            print "               '                "
            print '='*75
            print "\nFor HELP use -h or --help\n"
            print '='*55, "\n"
            return False
        return options

